import { EntityComponentTypes, world, system } from "@minecraft/server"

world.beforeEvents.worldInitialize.subscribe(event => {
    event.itemComponentRegistry.registerCustomComponent("martyrboss:gunshot", {
        onUse: e => {
            const player = e.source

            if (player.hasTag('has_ammo') && !player.isSneaking) {
                player.runCommandAsync('/scoreboard players add @s martyrboss:ammo -1')
                GunShoot(player)
                player.runCommandAsync('/playsound weapon.ww.shot @p')
            }
            else if (!player.hasTag('has_ammo')) {
                player.runCommandAsync('/playsound weapon.ww.click @p')
            }
        }
    })
})

function GunShoot(player) {
    const playerViewDirection = player.getViewDirection();
    const velocityMultiplier = 5.0;

    const projectile = player.dimension.spawnEntity("martyrboss:glizzbullet", {
        x: player.location.x + playerViewDirection.x,
        y: player.location.y + 1.5 + playerViewDirection.y,
        z: player.location.z + playerViewDirection.z,
    });

    const projectileComponent = projectile.getComponent(EntityComponentTypes.Projectile);
    const { x: vx, y: vy, z: vz } = player.getViewDirection();

    projectileComponent.shoot({
        x: vx * velocityMultiplier,
        y: vy * velocityMultiplier,
        z: vz * velocityMultiplier
    });
    projectileComponent.owner = player;
}

world.afterEvents.projectileHitEntity.subscribe(event => {
    const victim = event.getEntityHit().entity
    const projectile = event.projectile

    if (victim.typeId === 'martyrboss:boss_martyr2' && projectile.typeId === 'martyrboss:glizzbullet' && !victim.hasTag('is_dying')) {
        system.run(() => {
            const healthcomp = victim.getComponent('minecraft:health')
            const health = healthcomp.currentValue

            healthcomp.setCurrentValue(health - 3)
        })

    }
    if (victim.typeId === 'martyrboss:roxama24b' && projectile.typeId === 'martyrboss:glizzbullet') {
        system.run(() => {
            victim.applyDamage(5)
        })

    }
})